# -*- coding: utf-8 *-*

################################################################################
# activateLfrMode
# SVS-0034 (REQ-LFR-SRS-5509)
# SSS-CP-FS-320
################################################################################
# execfile('/opt/PYTHON/lfrverif/LFR_SVS/SVS-0034/activateLfrModeTiming.py')
#import sys

## To ensure the imported modified files are properly reloaded.
#for mod in sys.modules.values():
    #strmod = str(mod)
    #if not ('\'PythonQt' in strmod) and not ('\'sys\'' in strmod) and \
        #not ('\'pygments.' in strmod) and \
        #not ('\'__main__\'' in strmod) and not ('\'paste\'' in strmod) and \
        #not ('\'/usr/lib64/python2.7/' in strmod) and not(mod is None):
    ##if ('\'lfrverif' in strmod):
        #print mod
        #reload(mod)

import inspect
from lfrverif.common.param import *
#import time
from datetime import datetime

# setting up LPPMON plugins
from __main__ import proxy
if not(proxy.instanceExists("RMAPPlugin0")):
    proxy.loadSysDriver("RMAPPlugin", "RMAPPlugin0")
    from lfrverif.BridgeDef.bridge_def import bridge_id

    proxy.loadSysDriverToParent("dsu3plugin", "RMAPPlugin0")
    dsu3plugin0.openFile(LFR_FSW_PATH)
    dsu3plugin0.loadFile()
    dsu3plugin0.run()

from __main__ import RMAPPlugin0

from lfrverif.common.actions_tc_lfr_launcher import *
from lfrverif.common.test_monitor import time_sent
from lfrverif.common.miscellaneous.fun_misc import *

ACK_EXECUTION_COMPLETION = 1
ACK_ACCEPTANCE = 1
SOURCE_ID = SOURCE_ID_ENUM[0]

rk10 = SPW_HEADER_SIZE + 10
rk11 = SPW_HEADER_SIZE + 11
rk12 = SPW_HEADER_SIZE + 12
rk14 = SPW_HEADER_SIZE + 14
rk16 = SPW_HEADER_SIZE + 16
rk18 = SPW_HEADER_SIZE + 18
log_time = ""

current_file = inspect.currentframe().f_code.co_filename

test_launcher = TestLauncher(RMAPPlugin0, bridge_id)
test_launcher.test_monitor.progress_memo += (
    "SocExplorerEngine.getSocExplorer: Version = " + SocExplorerEngine.getSocExplorerVersion() +
    ", Branch = " + SocExplorerEngine.getSocExplorerBranch() +
    ", Changeset = " + SocExplorerEngine.getSocExplorerChangeset() + '\n')

test_launcher.test_monitor.log_memo(current_file)
postponeNextTimeBeforeTc(1)

tc_lfr_enter_mode = TcLfrEnterMode()
tc_lfr_update_time = TcLfrUpdateTime()

init_tc_header([tc_lfr_enter_mode, tc_lfr_update_time],
    ACK_EXECUTION_COMPLETION, ACK_ACCEPTANCE, SOURCE_ID)

# For this TC, Msb of byte 11 is used (for spare)
spare = tc_lfr_enter_mode.SpW[SPW_HEADER_SIZE + 11] & 0xf0

# Initial mode is NORMAL (ie cp_lfr_mode=1):
tc_lfr_enter_mode.SpW[rk11] = spare | 1
tc_lfr_enter_mode.ComputeCrc()

#tc_lfr_enter_mode.SpW[rk12:rk18] = CUC0[:]
dispCrcSendSpwTcWaitVerifPkt(test_launcher, tc_lfr_enter_mode)
surveyAnyTmPacket(test_launcher, 2)  # delay to verify the current mode

#    cp_rpw_time_aux = 0x7fffffff & random.randrange(0xffffffff)
#    tc_lfr_update_time.SpW[rk10:rk14] =\
#        [(cp_rpw_time_aux >> 24) & 0xff, (cp_rpw_time_aux >> 16) & 0xff,
#        (cp_rpw_time_aux >> 8) & 0xff, cp_rpw_time_aux & 0xff]
#    tc_lfr_update_time.ComputeCrc()
#    displayInfoSendTc(test_launcher, tc_lfr_update_time)
#    surveyAnyTmPacket(test_launcher, SY_RPW_CTR_FREQUENCY)

# je me mets au 1er juillet 2014
# 23h10 = 0x1B45 FD97 0000
tc_lfr_update_time.SpW[rk10:rk14] = [ 0x1B,0x45,0xfd,0x97]
tc_lfr_update_time.ComputeCrc()
dispCrcSendSpwTcSurvey(test_launcher, tc_lfr_update_time)
surveyAnyTmPacket(test_launcher, .3)

RMAPPlugin0.sendOneTimecode()
surveyAnyTmPacket(test_launcher, 340)

f_detail = open('lfr_internal_time.txt', 'w')
f_detail.write(log_time)
f_detail.close()

# Final mode in STANDBY (ie cp_lfr_mode=0):
tc_lfr_enter_mode.SpW[rk11] = spare
tc_lfr_enter_mode.SpW[rk12:rk18] = CUC0[:]
dispCrcSendSpwTcWaitVerifPkt(test_launcher, tc_lfr_enter_mode)
surveyAnyTmPacket(test_launcher, 1)  # delay to verify the current mode

test_launcher.test_monitor.log_memo("End(" + current_file + ")")
test_launcher.test_monitor.archivalRecord()
